/*
 *	Header file for encode.c plus parameter structures.
 *
 *	Copyright (c) 2002 John Edwards
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _ENCODE_H_
# define _ENCODE_H_

#include <windows.h>
#include "get_audio.h"        

#define         MAX_NAME_SIZE           1000


/* GLOBAL VARIABLES used by parse.c and main.c.  
   instantiated in parce.c.  ugly, ugly */
extern sound_file_format input_format;   
extern int swapbytes;              /* force byte swapping   default=0*/
extern int silent;
extern int enc_delay;
extern int disable_wav_header;
extern int enc_padding;

extern mp3data_struct mp3input_data; /* used by Ogg and MP3 */
extern int in_signed;
#define order_littleEndian 0
extern int in_endian;
extern int in_bitwidth;


#define         Min(A, B)       ((A) < (B) ? (A) : (B))
#define         Max(A, B)       ((A) > (B) ? (A) : (B))

void encode_error(char *errmsg);

typedef struct
{
	int   set_bitrate;
	int   mono;
	int   quality;
	float vbr_quality;
	int   set_cbr;
	int   abr_bitrate;
	int   cbr_bitrate;
	int   delete_input;
	char  *Title;
	char  *Artist;
	char  *Album;
	char  *Dates;
	char  *Genre;
	int   tagMode;
	int   AUTOtag;
	int   id3Tag;
	int   scale_mode;
	double scale;
} le_options;



int
lame_decoder(lame_global_flags * gfp, FILE * outf, int skip, char *inPath,
             char *outPath, le_enc_opt *opt, int *enc_delay, int *enc_padding);

int
lame_encoder(lame_global_flags * gf, FILE * outf, char *inPath,
             char *outPath, le_enc_opt *opt);

typedef struct {
	char	TitleFormat[32];
	int	window_x;
	int	window_y;
	int	always_on_top;
	int	logerr;
	int	delete_input;
	int	set_bitrate;
	int	mono;
	int	quality;
	int	vbr_quality;
	int	set_cbr;
	int	abr_bitrate;
	int	cbr_bitrate;
	int	tag_mode;
	int	auto_tag;
	int	id3Tag;
	char    title[64];
	char    artist[64];
	char    album[64];
	char    genre[64];
	char    year[32];
	int     out_dir_mode;
	char    out_dir[MAX_PATH];
	int     scale_mode;
} SettingsLAME;

/************************ GLOBALS *************************/
SettingsLAME iniSettings;


#endif /* _ENCODE_H_ */

